<!-- 任务中心 -->
<template>
	<view class="container">
		<view class="task_bg u-absolute">
			<image class="task_bg" src="../../static/images/me/task_bg.png"></image>
		</view>
		<u-navbar v-if="!isIos" :background="background" :is-back="false" :title="title"
			:border-bottom="false"></u-navbar>
		<view class="navTitle" v-else>
			<view></view>
			<view class="title">任务大厅</view>
			<image @click="goNav({jumpType:1,buttonUrl:'/pages/me/index'})" class="navTitleIcon"
				src="../../static/images/my.png"></image>
		</view>
		<view class="icon u-relative padding">
			<image class="task_icon1 u-relative" src="../../static/images/me/task_icon1.png"></image>
			<view class="icon_title u-font-32 text-bold u-relative">新人好礼送不停</view>
			<image class="task_icon2 u-relative" src="../../static/images/me/task_icon2.png"></image>
		</view>
		<view v-if="enable!=0&&signInList.length>0" class="content signIn margin-lr padding bg-white u-relative" style="margin-bottom: 32rpx;">
			
			<view class="title flex justify-between">
				<view>已连续签到 <text class="num">{{signDays}}</text> 天</view>
				<!-- 	<view class="dk flex">
					<text style="margin-right: 20rpx;">打卡提醒</text>
					<u-switch v-model="checked" size="35" active-color="#EA9EA8 "></u-switch>
				</view> -->
				<!-- <view class="tooltip-trigger" @click="showTooltip">
					<u-icon name="question-circle" :size="40"></u-icon>
					<view class="tooltip" v-if="isTooltipVisible">
					    签到中断后需重新签到
						<view class="triangle"></view>
						<view class="trianglef"></view>
					</view>
				</view> -->
			</view>
			<view class="signInList flex justify-between">
				<text class="line"></text>
				<view class="signIn-Item"
					:class="{active: item.showText == '待签到'||item.showText == '未签到'||item.showText == '已签到'}"
					v-for="(item,index) in signInList" :key="index">
					<image class="signIn_icon" v-if="item.showText == '未签到'" src="../../static/images/signIn_icon2.png"
						mode="" />
					<image class="signIn_icon" v-if="item.showText == '已签到'" src="../../static/images/signIn_icon3.png"
						mode="" />
					<image class="signIn_icon" v-if="item.showText != '未签到'&&item.showText != '已签到'"
						src="../../static/images/signIn_icon1.png" mode="" />
					<view class="radius"></view>
					<view class="_label">{{item.showText}}</view>
					<view class="_label" style="font-size: 18rpx;color: #999;margin-top: 2rpx;">{{item.signDay.slice(5,10)}}</view>
				</view>
			</view>

			<!-- <view class="tishi">连续签到7天即可获得7元奖励</view> -->

			<!-- <view class="signInBtn" @click="goNav({jumpType: 0, id:15, buttonTitle: '去领取'})">
				<view>{{signInBtn}}</view>
				<view class="signInBtnBg"></view>
			</view> -->

		</view>
		
		<view class="content margin-lr padding bg-white u-relative" v-if="list.length">
			<view class="cell flex justify-between" v-for="(item,index) in list" :key="index"
				v-if="item.show">
				<view class="cell_left flex">
					<view class="cell_title flex">
						<view class="u-font-28 text-bold title"
							:style="{alignSelf: item.rewardImg?'center':'flex-start'}">{{ item.title}}</view>
						<u-image v-if="item.rewardImg" class="cell_icon" :src="item.rewardImg "></u-image>
						<view class="u-font-24 tip">{{ item.rewardDetail  }}</view>
					</view>
					<view class="subhead u-font-24">{{ item.detail }}</view>
				</view>
				<view class="cell_right flex">
					<view v-if=" item.disabled " class="btn u-font-24 text-bold"
						:style="{backgroundColor: item.buttonBgColor,color: item.buttonFontColor }"
						@click="goNav(item)">
						{{ item.type == 1 ? item.buttonTitle : item.number ? `${item.discNumber}/${item.number}` : ( item.discNumber <= 0 ? item.buttonTitle : `剩余${item.discNumber}次`) }}
					</view>
					<view v-else class="btn u-font-24 text-bold disabled">
						{{ item.type == 1 ? item.buttonTitle : item.number ? `${item.discNumber}/${item.number}` : ( item.discNumber <= 0 ? item.buttonTitle : `剩余${item.discNumber}次`) }}
					</view>
					<!-- <view v-else class="btn u-font-24 text-bold" @click="goNav(item)">{{ item.buttonTitle }}</view> -->
					<view v-if=" item.buttonUnderContent && item.buttonUnderUrl " class="u-font-22 tip"
						@click="goNav({id: item.id,buttonUrl: item.buttonUnderUrl, jumpType: 1,title: item.title, disabled: item.disabled, discNumber: item.discNumber})">
						{{ item.buttonUnderContent}}
					</view>
				</view>
			</view>
		</view>
		<!-- 激励视频广告 -->
		<ad-rewarded-video v-if="adRewardedVideo" ref="adRewardedVideo" adpid="1531580352" :loadnext="true" v-slot:default="{loading, error}"
			:url-callback="urlCallback" @load="onadload" @close="onadclose" @error="onaderror">
			<view class="ad-error" v-if="error">{{error}}</view>
		</ad-rewarded-video>
	</view>
</template>

<script>
	import {$cache_renwu} from '@/store/cashe.js'
	import {isEmpty} from '@/utils/util.js'
	
	
	export default {

		data() {
			return {
				title: '',
				background: {
					backgroundImage: 'linear-gradient(to right, #FFE5EA 0%, #E4F5FB 49%, #FFF0EE 100%)'
				},
				list: [],
				checked: false,
				signDays: 0,
				enable: 0,
				signInList: [],
				recordList: [
				],
				signInBtn: '点击签到',
				isIos: false,
				isAndroid: false, 
				adRewardedVideo: true,
				adRewardedVideoloadNum: 0,
				urlCallback: null,
			    isTooltipVisible: false,
				tooltipTimeout: null,
			}
		},
		onShow() {
			this.signInList = []
			this.getTaskdata()
			this.getsignIn()
			this.$nextTick(()=>{
				this.adRewardedVideoloadNum = 0
				this.$refs.adRewardedVideo.load();
			})
			
		},
	
		methods: {
			/**
			 * 签到提示出发
			 */
			showTooltip() {
		        clearTimeout(this.tooltipTimeout);
		        this.isTooltipVisible = !this.isTooltipVisible;
				this.tooltipTimeout = setTimeout(() => {
					this.isTooltipVisible = false;
				}, 1000); // 1000毫秒后隐藏tooltip
			},
			
			/**
			 * 广告数据加载成功回调
			 * @param {Object} e
			 */
			onadload(e) {
				this.adRewardedVideo = true;
				console.log('广告数据加载成功');
			},
			
			/**
			 * 广告加载失败回调
			 * @param {Object} e
			 */
			onaderror(e) {
				if ( this.adRewardedVideoloadNum >=3 ) {
					this.adRewardedVideo = false;
					return
				} 
				this.adRewardedVideoloadNum++
				setTimeout(() => {
					this.$refs.adRewardedVideo.load();
				}, 1000); // 10
				console.log("广告加载失败")
			},
			
			/**
			 * 广告播放成功回调
			 * @param {Object} e
			 */
			async onadclose(e) {
				const detail = e.detail
				if (detail && detail.isEnded) {
					// 正常播放结束
					// /sqx_fast/app/ad/state
					let res = await this.$Request.getT('app/ad/state', {
						extraKey: this.urlCallback.extra
					})
					this.$Request.getT('/app/common/type/921').then(res => {
						if (res.code == 0) {
							console.log(res)
							uni.showToast({
								title: '获得' + res.data.value + '分钟免费时长',
								icon: 'none'
							})
						}
					})
				} else {
					// 播放中途退出
				}
			},
			
			/**
			 * 获取签到数据
			 */
			getsignIn() {
				if($cache_renwu.signInList&&!isEmpty($cache_renwu.signDays)&&!isEmpty($cache_renwu.enable) ){
					this.signInList =$cache_renwu.signInList
					this.signDays =$cache_renwu.signDays
					this.enable =$cache_renwu.enable
					return 
				}
				this.$Request.getT('app/userSignRecord/getUserSignData', {}).then(res => {
					if (res.code == 0) {
						this.signInList = res.data.recordList
						this.signDays = res.data.signDays
						this.enable = res.data.enable
						this.signInList.map((item, index) => {
							if (item.showText == '待签到' && index > 0) {
								this.signInBtn = this.signInList[index - 1].status == 0 ? '重新签到' : '点击签到'
							}
							let someDate = new Date(item.signDay); // 假设这是需要判断的日期
							if (item.signDate && this.isToday(someDate)) {
								this.signInBtn = '已签到'
							}
						})
						$cache_renwu.set('signInList',this.signInList)
						$cache_renwu.set('signDays',this.signDays)
						$cache_renwu.set('enable',this.enable)
					} else {
						// uni.showToast({
						// 	title: res.msg,
						// 	icon: 'none'
						// })
					}
				})
			},

			/**
			 * 校验是否为当天
			 * @param date 
			 */
			isToday(date) {
				const today = new Date();
				return date.getDate() === today.getDate() // 比较日期
					&&
					date.getMonth() === today.getMonth() // 比较月份
					&&
					date.getFullYear() === today.getFullYear(); // 比较年份
			},

			/**
			 * 跳转
			 * @param {Object} item
			 */
			goNav(item) {
				// jumpType (integer, optional): 跳转类型 1 内部路径 2 外部路径 ,
				// type (integer, optional): 任务类型 1 普通任务 2 打卡任务 9 其它 ,
				// buttonUrl
				if (item.jumpType == 0) {
					if (item.buttonTitle.indexOf("领取") != -1) {
						this.taskReceive(item.id)
					} else if (item.buttonTitle.indexOf("观看视频") != -1) {
						// 首次加载广告 
						
						
						this.urlCallback = {
							userId: uni.getStorageSync('userId'),
							extra: uni.getStorageSync('userId') + "" + new Date().getTime(),
						}
						this.$refs.adRewardedVideo.show();
					} else {
						uni.switchTab({
							url: "/pages/index/index"
						})
					}
				} else if (item.jumpType == 1) {
					let source, buttonUrl;
					buttonUrl = item.buttonUrl
					console.log(item.title && item.title.indexOf('每周打卡奖励') != -1)
					if (item.title && item.title.indexOf('每周打卡奖励') != -1) {
						source = 2
						buttonUrl = item.buttonUrl + '?source=' + source
					}
					if (item.title && item.title.indexOf('每月打卡奖励1') != -1) {
						source = 3
						buttonUrl = item.buttonUrl + '?source=' + source
					}
					if (item.title && item.title.indexOf('每月打卡奖励2') != -1) {
						buttonUrl = `${item.buttonUrl}?standard=${item.discNumber==null?true:false}&taskId=${item.id}`
					}
					console.log(buttonUrl)
					uni.navigateTo({
						url: buttonUrl
					})
				} else if (item.jumpType == 3) {
					uni.switchTab({
						url: item.buttonUrl
					})
				} else if (item.jumpType == 2) {
					plus.runtime.openURL(item.buttonUrl)
				}

			},

			/**
			 * 领取
			 */
			taskReceive(id) {
				let data = {
					id: id
				}
				this.$Request.getT('app/taskCenter/taskReceive', data).then(res => {
					if (res.code == 0) {
						uni.showToast({
							title: id == 15 ? '签到成功' : '领取成功',
							icon: 'none'
						})
						setTimeout(() => {
							$cache_renwu.clear()
							this.getTaskdata()
							this.getsignIn()
						}, 1000)
					} else {
						uni.switchTab({
							url: "/pages/index/index"
						})
					}
				})
			},

			/**
			 * 获取任务列表
			 */
			getTaskdata() {
				if($cache_renwu.list){
					this.list= $cache_renwu.list
					uni.stopPullDownRefresh();
					return 
				}
				console.log('获取服务器 任务列表')
				this.list= [];
				this.$Request.getT('app/taskCenter/selectTaskCenter', {}).then(res => {
					if (res.code == 0) {
						this.list = res.data
						this.list.map(item=>{
							item.show = true
						})
						this.list.map(item=>{
							if(item.title.indexOf("观看视频") != -1&&!this.adRewardedVideo) {
								item.show = false 
							}
							// #ifdef H5
							if(item.title.indexOf("观看视频") != -1) {
								item.show = false
							} 
							// #endif
						})
						$cache_renwu.set('list',this.list)
					}
					uni.stopPullDownRefresh();
				})
			},

			/**
			 * 下拉加载
			 */
			onPullDownRefresh: function() {
				console.log(2)
				$cache_renwu.clear()
				this.getsignIn()
				this.getTaskdata();
			},

		}
	}
</script>

<style lang="scss">
	page{
		background-color: #F3F4F8;
	}
	.tooltip-trigger {
	  // background-color: #f0f0f0;
	  // border: 1px solid #ddd;
	  text-align: center;
	
	}
	 
	.tooltip {
	  padding: 10px;
	  background-color: #fff;
	  color: #999;
	  box-shadow: 0rpx 4rpx 10rpx 4rpx rgba(140,140,140,0.35);
	  border-radius: 10rpx 10rpx 10rpx 10rpx;
	  position: absolute;
	  top: 80rpx;
	  right: 30rpx;
	  z-index: 10;
	  font-weight: 400;
	  font-size: 20rpx;
	  color: #999999;
	}
	.triangle,.trianglef {
		position: absolute;
		z-index: 99;
		right: 15rpx;
		top: -16rpx;
		width: 0;
		height: 0;
		border-left: 17rpx solid transparent;
		/* 左边的边框为透明 */
		border-right: 17rpx solid transparent;
		/* 右边的边框为透明 */
		border-bottom: 17rpx solid rgba(140,140,140,0.15);
		opacity: .9;
		z-index: 8;
	}
	.trianglef{
		top: -15rpx;
		right: 17rpx;
		border-left: 15rpx solid transparent;
		/* 左边的边框为透明 */
		border-right: 15rpx solid transparent;
		border-bottom: 15rpx solid #fff;
		z-index: 11;
	}
	.container {
		width: 100%;
		// height: 100vh;
		background-color: #F3F4F8;
		// padding-bottom: 132rpx;
		.task_bg {
			width: 100% !important;
			height: 494rpx !important;
		}

		.icon {
			.icon_title {
				color: #000000;
				margin-left: 28rpx;
				top: -20rpx;

			}

			.task_icon1 {
				width: 74rpx !important;
				height: 78rpx !important;
				margin-left: 235rpx;
			}

			.task_icon2 {
				width: 126rpx !important;
				height: 120rpx !important;
				top: -40rpx;
			}
		}

		.navTitle {
			width: 100%;
			position: relative;
			z-index: 9;
			display: flex;
			align-items: center;
			justify-content: space-between;
			padding: 106rpx 28rpx 0 28rpx;

			.title {
				font-weight: bold;
				font-size: 40rpx;
				color: #000000;
			}

			.navTitleIcon {
				width: 40.48rpx !important;
				height: 46rpx !important;
				align-self: flex-end;
			}
		}

		.content {
			border-radius: 16rpx;
			top: -115rpx;
			padding: 28rpx;


			.cell {
				align-items: center;
				padding: 32rpx 0;
				border-bottom: 2rpx solid #EBEBEB;

				.cell_left {
					flex-direction: column;

					.cell_title {
						align-items: center;
						margin-bottom: 12rpx;
						color: #333;

						.title {
							flex-shrink: 0;
						}

						.cell_icon {
							width: 34rpx !important;
							height: 34rpx !important;
							margin-left: 16rpx;
						}

						.tip {
							margin-left: 22rpx;
							color: #FC5B67;
						}
					}

					.subhead {
						color: #999;
					}
				}

				.cell_right {
					flex-direction: column;
					align-items: center;
					flex-shrink: 0;
					margin-left: 20rpx;

					.btn {
						width: 148rpx;
						height: 56rpx;
						line-height: 56rpx;
						text-align: center;
						background-color: #EC6F48;
						color: #FFFFFF;
						border-radius: 12rpx 12rpx 12rpx 12rpx;
					}

					.tip {
						color: #EC6F48;
						height: 44rpx;
						line-height: 44rpx;
						margin-top: 5rpx;
					}

					.opt {
						color: #D39B7E;
						background-color: #FBF3EB;
					}

					.disabled {
						color: #999999;
						background-color: #E2E2E2;
					}
				}

			}

			.cell:last-child {
				border-bottom: none;
			}
		}

		.signIn {
			>.title {
				font-weight: 400;
				font-size: 32rpx;
				color: #666666;

				.num {
					font-weight: bold;
					color: #EC6F48;
					margin: 0 10rpx;
				}

				.dk {
					font-weight: 400;
					font-size: 24rpx;
					color: #333333;
					align-items: center;
				}
			}

			.signInList {
				margin-top: 24rpx;
				margin-bottom: 26rpx;
				position: relative;

				.line {
					width: 92%;
					height: 0rpx;
					border-radius: 0rpx 0rpx 0rpx 0rpx;
					border: 2rpx solid #D8D5D5;
					position: absolute;
					left: 0;
					right: 0;
					bottom: 82rpx;
					margin: auto;
				}

				.signIn-Item {
					display: flex;
					flex-direction: column;
					align-items: center;
					position: relative;
					z-index: 5;

					.signIn_icon {
						width: 52.33rpx;
						height: 51.68rpx;
						margin-bottom: 32rpx;
					}

					.radius {
						width: 26rpx;
						height: 26rpx;
						border-radius: 10rpx;
						background-color: #D8D5D5;

					}

					._label {
						font-weight: 400;
						font-size: 18rpx;
						color: #333333;
						margin-top: 24rpx;
					}
				}

				.signIn-Item.active {
					.radius {
						background-color: #EA9EA8;

					}
				}
			}

			.tishi {
				width: 100%;
				text-align: center;
				font-weight: 400;
				font-size: 20rpx;
				color: #7F7F7F;
			}

			.signInBtn {
				width: 355rpx;
				height: 64rpx;
				line-height: 64rpx;
				font-weight: 400;
				font-size: 32rpx;
				color: #FFFFFF;
				text-align: center;
				background: #EA9EA8;
				border-radius: 14rpx 14rpx 14rpx 14rpx;
				margin: 32rpx auto;
				box-shadow: 0 0 0 rgba(234, 158, 168, 0.75);
				position: relative;
			}

			.signInBtnBg {
				width: 327rpx;
				height: 52rpx;
				background: rgba(234, 158, 168, 0.75);
				border-radius: 14rpx 14rpx 14rpx 14rpx;
				opacity: 0.31;
				position: absolute;
				bottom: -10rpx;
				left: 0;
				right: 0;
				margin: auto;
			}
		}
	}
</style>